diff -NurpP --minimal linux-3.0/arch/mips/Kconfig torvalds-linux-v3.1-rc10/arch/mips/Kconfig
--- linux-3.0/arch/mips/Kconfig	2011-08-29 03:03:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -24,6 +24,7 @@ config MIPS
 	select GENERIC_IRQ_PROBE
 	select GENERIC_IRQ_SHOW
 	select HAVE_ARCH_JUMP_LABEL
+	select IRQ_FORCED_THREADING
 
 menu "Machine selection"
 
@@ -185,6 +186,7 @@ config MACH_JAZZ
 	select CSRC_R4K
 	select DEFAULT_SGI_PARTITION if CPU_BIG_ENDIAN
 	select GENERIC_ISA_DMA
+	select HAVE_PCSPKR_PLATFORM
 	select IRQ_CPU
 	select I8253
 	select I8259
@@ -266,6 +268,7 @@ config MIPS_MALTA
 	select CSRC_R4K
 	select DMA_NONCOHERENT
 	select GENERIC_ISA_DMA
+	select HAVE_PCSPKR_PLATFORM
 	select IRQ_CPU
 	select IRQ_GIC
 	select HW_HAS_PCI
@@ -640,6 +643,7 @@ config SNI_RM
 	select DEFAULT_SGI_PARTITION if CPU_BIG_ENDIAN
 	select DMA_NONCOHERENT
 	select GENERIC_ISA_DMA
+	select HAVE_PCSPKR_PLATFORM
 	select HW_HAS_EISA
 	select HW_HAS_PCI
 	select IRQ_CPU
@@ -719,6 +723,7 @@ config CAVIUM_OCTEON_SIMULATOR
 	select SYS_SUPPORTS_HIGHMEM
 	select SYS_SUPPORTS_HOTPLUG_CPU
 	select SYS_HAS_CPU_CAVIUM_OCTEON
+	select HOLES_IN_ZONE
 	help
 	  The Octeon simulator is software performance model of the Cavium
 	  Octeon Processor. It supports simulating Octeon processors on x86
@@ -741,6 +746,7 @@ config CAVIUM_OCTEON_REFERENCE_BOARD
 	select ZONE_DMA32
 	select USB_ARCH_HAS_OHCI
 	select USB_ARCH_HAS_EHCI
+	select HOLES_IN_ZONE
 	help
 	  This option supports all of the Octeon reference boards from Cavium
 	  Networks. It builds a kernel that dynamically determines the Octeon
@@ -970,6 +976,9 @@ config ISA_DMA_API
 config GENERIC_GPIO
 	bool
 
+config HOLES_IN_ZONE
+	bool
+
 #
 # Endianess selection.  Sufficiently obscure so many users don't know what to
 # answer,so we try hard to limit the available choices.  Also the use of a
@@ -2388,6 +2397,7 @@ config MMU
 config I8253
 	bool
 	select CLKSRC_I8253
+	select CLKEVT_I8253
 	select MIPS_EXTERNAL_TIMER
 
 config ZONE_DMA32
@@ -2489,20 +2499,4 @@ source "security/Kconfig"
 
 source "crypto/Kconfig"
 
-menuconfig VIRTUALIZATION
-	bool "Virtualization"
-	default n
-	---help---
-	  Say Y here to get to see options for using your Linux host to run other
-	  operating systems inside virtual machines (guests).
-	  This option alone does not add any kernel code.
-
-	  If you say N, all options in this submenu will be skipped and disabled.
-
-if VIRTUALIZATION
-
-source drivers/virtio/Kconfig
-
-endif # VIRTUALIZATION
-
 source "lib/Kconfig"
diff -NurpP --minimal linux-3.0/arch/mips/Makefile torvalds-linux-v3.1-rc10/arch/mips/Makefile
--- linux-3.0/arch/mips/Makefile	2011-08-29 03:03:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/Makefile	2011-10-18 04:06:23.000000000 +0000
@@ -191,18 +191,6 @@ endif
 #
 include $(srctree)/arch/mips/Kbuild.platforms
 
-#
-# NETLOGIC SOC Common (common)
-#
-cflags-$(CONFIG_NLM_COMMON)		+= -I$(srctree)/arch/mips/include/asm/mach-netlogic
-cflags-$(CONFIG_NLM_COMMON)		+= -I$(srctree)/arch/mips/include/asm/netlogic
-
-#
-# NETLOGIC XLR/XLS SoC, Simulator and boards
-#
-core-$(CONFIG_NLM_XLR)      		+= arch/mips/netlogic/xlr/
-load-$(CONFIG_NLM_XLR_BOARD)		+= 0xffffffff84000000
-
 cflags-y			+= -I$(srctree)/arch/mips/include/asm/mach-generic
 drivers-$(CONFIG_PCI)		+= arch/mips/pci/
 
diff -NurpP --minimal linux-3.0/arch/mips/alchemy/common/platform.c torvalds-linux-v3.1-rc10/arch/mips/alchemy/common/platform.c
--- linux-3.0/arch/mips/alchemy/common/platform.c	2011-08-29 03:03:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/alchemy/common/platform.c	2011-10-18 04:06:23.000000000 +0000
@@ -492,7 +492,7 @@ static void __init alchemy_setup_macs(in
 		memcpy(au1xxx_eth0_platform_data.mac, ethaddr, 6);
 
 	ret = platform_device_register(&au1xxx_eth0_device);
-	if (!ret)
+	if (ret)
 		printk(KERN_INFO "Alchemy: failed to register MAC0\n");
 
 
diff -NurpP --minimal linux-3.0/arch/mips/alchemy/common/power.c torvalds-linux-v3.1-rc10/arch/mips/alchemy/common/power.c
--- linux-3.0/arch/mips/alchemy/common/power.c	2011-04-03 18:50:25.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/alchemy/common/power.c	2011-10-18 04:06:23.000000000 +0000
@@ -158,15 +158,21 @@ static void restore_core_regs(void)
 
 void au_sleep(void)
 {
-	int cpuid = alchemy_get_cputype();
-	if (cpuid != ALCHEMY_CPU_UNKNOWN) {
-		save_core_regs();
-		if (cpuid <= ALCHEMY_CPU_AU1500)
-			alchemy_sleep_au1000();
-		else if (cpuid <= ALCHEMY_CPU_AU1200)
-			alchemy_sleep_au1550();
-		restore_core_regs();
+	save_core_regs();
+
+	switch (alchemy_get_cputype()) {
+	case ALCHEMY_CPU_AU1000:
+	case ALCHEMY_CPU_AU1500:
+	case ALCHEMY_CPU_AU1100:
+		alchemy_sleep_au1000();
+		break;
+	case ALCHEMY_CPU_AU1550:
+	case ALCHEMY_CPU_AU1200:
+		alchemy_sleep_au1550();
+		break;
 	}
+
+	restore_core_regs();
 }
 
 #endif	/* CONFIG_PM */
diff -NurpP --minimal linux-3.0/arch/mips/alchemy/devboards/bcsr.c torvalds-linux-v3.1-rc10/arch/mips/alchemy/devboards/bcsr.c
--- linux-3.0/arch/mips/alchemy/devboards/bcsr.c	2011-06-22 15:07:55.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/alchemy/devboards/bcsr.c	2011-10-18 04:06:23.000000000 +0000
@@ -89,8 +89,12 @@ static void bcsr_csc_handler(unsigned in
 {
 	unsigned short bisr = __raw_readw(bcsr_virt + BCSR_REG_INTSTAT);
 
+	disable_irq_nosync(irq);
+
 	for ( ; bisr; bisr &= bisr - 1)
 		generic_handle_irq(bcsr_csc_base + __ffs(bisr));
+
+	enable_irq(irq);
 }
 
 /* NOTE: both the enable and mask bits must be cleared, otherwise the
diff -NurpP --minimal linux-3.0/arch/mips/alchemy/devboards/db1200/setup.c torvalds-linux-v3.1-rc10/arch/mips/alchemy/devboards/db1200/setup.c
--- linux-3.0/arch/mips/alchemy/devboards/db1200/setup.c	2011-08-29 03:03:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/alchemy/devboards/db1200/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -23,13 +23,6 @@ void __init board_setup(void)
 	unsigned long freq0, clksrc, div, pfc;
 	unsigned short whoami;
 
-	/* Set Config[OD] (disable overlapping bus transaction):
-	 * This gets rid of a _lot_ of spurious interrupts (especially
-	 * wrt. IDE); but incurs ~10% performance hit in some
-	 * cpu-bound applications.
-	 */
-	set_c0_config(1 << 19);
-
 	bcsr_init(DB1200_BCSR_PHYS_ADDR,
 		  DB1200_BCSR_PHYS_ADDR + DB1200_BCSR_HEXLED_OFS);
 
diff -NurpP --minimal linux-3.0/arch/mips/ar7/clock.c torvalds-linux-v3.1-rc10/arch/mips/ar7/clock.c
--- linux-3.0/arch/mips/ar7/clock.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/ar7/clock.c	2011-10-18 04:06:23.000000000 +0000
@@ -443,7 +443,7 @@ struct clk *clk_get(struct device *dev,
 		return &vbus_clk;
 	if (!strcmp(id, "cpu"))
 		return &cpu_clk;
-	if (!strcmp(id, "dsp"));
+	if (!strcmp(id, "dsp"))
 		return &dsp_clk;
 	if (!strcmp(id, "vbus"))
 		return &vbus_clk;
diff -NurpP --minimal linux-3.0/arch/mips/ar7/irq.c torvalds-linux-v3.1-rc10/arch/mips/ar7/irq.c
--- linux-3.0/arch/mips/ar7/irq.c	2011-06-22 15:07:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/ar7/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -98,7 +98,8 @@ static struct irq_chip ar7_sec_irq_type
 
 static struct irqaction ar7_cascade_action = {
 	.handler = no_action,
-	.name = "AR7 cascade interrupt"
+	.name = "AR7 cascade interrupt",
+	.flags = IRQF_NO_THREAD,
 };
 
 static void __init ar7_irq_init(int base)
diff -NurpP --minimal linux-3.0/arch/mips/ar7/prom.c torvalds-linux-v3.1-rc10/arch/mips/ar7/prom.c
--- linux-3.0/arch/mips/ar7/prom.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/ar7/prom.c	2011-10-18 04:06:23.000000000 +0000
@@ -77,7 +77,7 @@ struct psp_env_chunk {
 	u16	csum;
 	u8	len;
 	char	data[11];
-} __attribute__ ((packed));
+} __packed;
 
 struct psp_var_map_entry {
 	u8	num;
diff -NurpP --minimal linux-3.0/arch/mips/bcm47xx/setup.c torvalds-linux-v3.1-rc10/arch/mips/bcm47xx/setup.c
--- linux-3.0/arch/mips/bcm47xx/setup.c	2011-08-29 03:03:59.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/bcm47xx/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  *  Copyright (C) 2004 Florian Schirmer <jolt@tuxbox.org>
  *  Copyright (C) 2006 Felix Fietkau <nbd@openwrt.org>
- *  Copyright (C) 2006 Michael Buesch <mb@bu3sch.de>
+ *  Copyright (C) 2006 Michael Buesch <m@bues.ch>
  *  Copyright (C) 2010 Waldemar Brodkorb <wbx@openadk.org>
  *  Copyright (C) 2010-2011 Hauke Mehrtens <hauke@hauke-m.de>
  *
diff -NurpP --minimal linux-3.0/arch/mips/bcm63xx/irq.c torvalds-linux-v3.1-rc10/arch/mips/bcm63xx/irq.c
--- linux-3.0/arch/mips/bcm63xx/irq.c	2011-06-22 15:07:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/bcm63xx/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -222,6 +222,7 @@ static struct irq_chip bcm63xx_external_
 static struct irqaction cpu_ip2_cascade_action = {
 	.handler	= no_action,
 	.name		= "cascade_ip2",
+	.flags		= IRQF_NO_THREAD,
 };
 
 void __init arch_init_irq(void)
diff -NurpP --minimal linux-3.0/arch/mips/cobalt/irq.c torvalds-linux-v3.1-rc10/arch/mips/cobalt/irq.c
--- linux-3.0/arch/mips/cobalt/irq.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/cobalt/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -48,6 +48,7 @@ asmlinkage void plat_irq_dispatch(void)
 static struct irqaction cascade = {
 	.handler	= no_action,
 	.name		= "cascade",
+	.flags		= IRQF_NO_THREAD,
 };
 
 void __init arch_init_irq(void)
diff -NurpP --minimal linux-3.0/arch/mips/cobalt/time.c torvalds-linux-v3.1-rc10/arch/mips/cobalt/time.c
--- linux-3.0/arch/mips/cobalt/time.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/cobalt/time.c	2011-10-18 04:06:23.000000000 +0000
@@ -17,10 +17,10 @@
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  */
+#include <linux/i8253.h>
 #include <linux/init.h>
 
 #include <asm/gt64120.h>
-#include <asm/i8253.h>
 #include <asm/time.h>
 
 #define GT641XX_BASE_CLOCK	50000000	/* 50MHz */
diff -NurpP --minimal linux-3.0/arch/mips/dec/setup.c torvalds-linux-v3.1-rc10/arch/mips/dec/setup.c
--- linux-3.0/arch/mips/dec/setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/dec/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -101,20 +101,24 @@ int cpu_fpu_mask = DEC_CPU_IRQ_MASK(DEC_
 static struct irqaction ioirq = {
 	.handler = no_action,
 	.name = "cascade",
+	.flags = IRQF_NO_THREAD,
 };
 static struct irqaction fpuirq = {
 	.handler = no_action,
 	.name = "fpu",
+	.flags = IRQF_NO_THREAD,
 };
 
 static struct irqaction busirq = {
 	.flags = IRQF_DISABLED,
 	.name = "bus error",
+	.flags = IRQF_NO_THREAD,
 };
 
 static struct irqaction haltirq = {
 	.handler = dec_intr_halt,
 	.name = "halt",
+	.flags = IRQF_NO_THREAD,
 };
 
 
diff -NurpP --minimal linux-3.0/arch/mips/emma/markeins/irq.c torvalds-linux-v3.1-rc10/arch/mips/emma/markeins/irq.c
--- linux-3.0/arch/mips/emma/markeins/irq.c	2011-06-22 15:07:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/emma/markeins/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -169,7 +169,7 @@ void emma2rh_gpio_irq_init(void)
 
 static struct irqaction irq_cascade = {
 	   .handler = no_action,
-	   .flags = 0,
+	   .flags = IRQF_NO_THREAD,
 	   .name = "cascade",
 	   .dev_id = NULL,
 	   .next = NULL,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/atomic.h
--- linux-3.0/arch/mips/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -303,15 +303,15 @@ static __inline__ int atomic_sub_if_posi
 #define atomic_xchg(v, new) (xchg(&((v)->counter), (new)))
 
 /**
- * atomic_add_unless - add unless the number is a given value
+ * __atomic_add_unless - add unless the number is a given value
  * @v: pointer of type atomic_t
  * @a: the amount to add to v...
  * @u: ...unless v is equal to u.
  *
  * Atomically adds @a to @v, so long as it was not @u.
- * Returns non-zero if @v was not @u, and zero otherwise.
+ * Returns the old value of @v.
  */
-static __inline__ int atomic_add_unless(atomic_t *v, int a, int u)
+static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
 	c = atomic_read(v);
@@ -323,9 +323,8 @@ static __inline__ int atomic_add_unless(
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c;
 }
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
 #define atomic_dec_return(v) atomic_sub_return(1, (v))
 #define atomic_inc_return(v) atomic_add_return(1, (v))
@@ -680,7 +679,7 @@ static __inline__ long atomic64_sub_if_p
  * @u: ...unless v is equal to u.
  *
  * Atomically adds @a to @v, so long as it was not @u.
- * Returns non-zero if @v was not @u, and zero otherwise.
+ * Returns the old value of @v.
  */
 static __inline__ int atomic64_add_unless(atomic64_t *v, long a, long u)
 {
@@ -766,10 +765,6 @@ static __inline__ int atomic64_add_unles
  */
 #define atomic64_add_negative(i, v) (atomic64_add_return(i, (v)) < 0)
 
-#else /* !CONFIG_64BIT */
-
-#include <asm-generic/atomic64.h>
-
 #endif /* CONFIG_64BIT */
 
 /*
@@ -781,6 +776,4 @@ static __inline__ int atomic64_add_unles
 #define smp_mb__before_atomic_inc()	smp_mb__before_llsc()
 #define smp_mb__after_atomic_inc()	smp_llsc_mb()
 
-#include <asm-generic/atomic-long.h>
-
 #endif /* _ASM_ATOMIC_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/fixmap.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/fixmap.h
--- linux-3.0/arch/mips/include/asm/fixmap.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/fixmap.h	2011-10-18 04:06:23.000000000 +0000
@@ -14,6 +14,7 @@
 #define _ASM_FIXMAP_H
 
 #include <asm/page.h>
+#include <spaces.h>
 #ifdef CONFIG_HIGHMEM
 #include <linux/threads.h>
 #include <asm/kmap_types.h>
@@ -67,15 +68,6 @@ enum fixed_addresses {
  * the start of the fixmap, and leave one page empty
  * at the top of mem..
  */
-#ifdef CONFIG_BCM63XX
-#define FIXADDR_TOP     ((unsigned long)(long)(int)0xff000000)
-#else
-#if defined(CONFIG_CPU_TX39XX) || defined(CONFIG_CPU_TX49XX)
-#define FIXADDR_TOP	((unsigned long)(long)(int)(0xff000000 - 0x20000))
-#else
-#define FIXADDR_TOP	((unsigned long)(long)(int)0xfffe0000)
-#endif
-#endif
 #define FIXADDR_SIZE	(__end_of_fixed_addresses << PAGE_SHIFT)
 #define FIXADDR_START	(FIXADDR_TOP - FIXADDR_SIZE)
 
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/floppy.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/floppy.h
--- linux-3.0/arch/mips/include/asm/floppy.h	2011-06-22 15:07:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/floppy.h	2011-10-18 04:06:23.000000000 +0000
@@ -29,7 +29,7 @@ static inline void fd_cacheflush(char *
 #define FLOPPY0_TYPE 		fd_drive_type(0)
 #define FLOPPY1_TYPE		fd_drive_type(1)
 
-#define FDC1			fd_getfdaddr1();
+#define FDC1			fd_getfdaddr1()
 
 #define N_FDC 1			/* do you *really* want a second controller? */
 #define N_DRIVE 8
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/gt64120.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/gt64120.h
--- linux-3.0/arch/mips/include/asm/gt64120.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/gt64120.h	2011-10-18 04:06:23.000000000 +0000
@@ -21,8 +21,6 @@
 #ifndef _ASM_GT64120_H
 #define _ASM_GT64120_H
 
-#include <linux/clocksource.h>
-
 #include <asm/addrspace.h>
 #include <asm/byteorder.h>
 
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/hw_irq.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/hw_irq.h
--- linux-3.0/arch/mips/include/asm/hw_irq.h	2011-06-22 15:07:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/hw_irq.h	2011-10-18 04:06:23.000000000 +0000
@@ -8,7 +8,7 @@
 #ifndef __ASM_HW_IRQ_H
 #define __ASM_HW_IRQ_H
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 extern atomic_t irq_err_count;
 
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/irq.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/irq.h
--- linux-3.0/arch/mips/include/asm/irq.h	2011-06-22 15:07:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/irq.h	2011-10-18 04:06:23.000000000 +0000
@@ -18,7 +18,6 @@
 
 static inline void irq_dispose_mapping(unsigned int virq)
 {
-	return;
 }
 
 #ifdef CONFIG_I8259
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/local.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/local.h
--- linux-3.0/arch/mips/include/asm/local.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/local.h	2011-10-18 04:06:23.000000000 +0000
@@ -3,7 +3,7 @@
 
 #include <linux/percpu.h>
 #include <linux/bitops.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/cmpxchg.h>
 #include <asm/war.h>
 
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-bcm63xx/bcm63xx_regs.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-bcm63xx/bcm63xx_regs.h
--- linux-3.0/arch/mips/include/asm/mach-bcm63xx/bcm63xx_regs.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-bcm63xx/bcm63xx_regs.h	2011-10-18 04:06:23.000000000 +0000
@@ -89,7 +89,6 @@
 
 /* Interrupt Mask register */
 #define PERF_IRQMASK_REG		0xc
-#define PERF_IRQSTAT_REG		0x10
 
 /* Interrupt Status register */
 #define PERF_IRQSTAT_REG		0x10
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-bcm63xx/spaces.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-bcm63xx/spaces.h
--- linux-3.0/arch/mips/include/asm/mach-bcm63xx/spaces.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-bcm63xx/spaces.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,17 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 1994 - 1999, 2000, 03, 04 Ralf Baechle
+ * Copyright (C) 2000, 2002  Maciej W. Rozycki
+ * Copyright (C) 1990, 1999, 2000 Silicon Graphics, Inc.
+ */
+#ifndef _ASM_BCM63XX_SPACES_H
+#define _ASM_BCM63XX_SPACES_H
+
+#define FIXADDR_TOP		((unsigned long)(long)(int)0xff000000)
+
+#include <asm/mach-generic/spaces.h>
+
+#endif /* __ASM_BCM63XX_SPACES_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-cavium-octeon/cpu-feature-overrides.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-cavium-octeon/cpu-feature-overrides.h
--- linux-3.0/arch/mips/include/asm/mach-cavium-octeon/cpu-feature-overrides.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-cavium-octeon/cpu-feature-overrides.h	2011-10-18 04:06:23.000000000 +0000
@@ -54,7 +54,6 @@
 #define cpu_has_mips_r2_exec_hazard 0
 #define cpu_has_dsp		0
 #define cpu_has_mipsmt		0
-#define cpu_has_userlocal	0
 #define cpu_has_vint		0
 #define cpu_has_veic		0
 #define cpu_hwrena_impl_bits	0xc0000000
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-generic/dma-coherence.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-generic/dma-coherence.h
--- linux-3.0/arch/mips/include/asm/mach-generic/dma-coherence.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-generic/dma-coherence.h	2011-10-18 04:06:23.000000000 +0000
@@ -49,7 +49,6 @@ static inline int plat_dma_supported(str
 
 static inline void plat_extra_sync_for_device(struct device *dev)
 {
-	return;
 }
 
 static inline int plat_dma_mapping_error(struct device *dev,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-generic/spaces.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-generic/spaces.h
--- linux-3.0/arch/mips/include/asm/mach-generic/spaces.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-generic/spaces.h	2011-10-18 04:06:23.000000000 +0000
@@ -82,4 +82,8 @@
 #define PAGE_OFFSET		(CAC_BASE + PHYS_OFFSET)
 #endif
 
+#ifndef FIXADDR_TOP
+#define FIXADDR_TOP		((unsigned long)(long)(int)0xfffe0000)
+#endif
+
 #endif /* __ASM_MACH_GENERIC_SPACES_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-ip27/dma-coherence.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-ip27/dma-coherence.h
--- linux-3.0/arch/mips/include/asm/mach-ip27/dma-coherence.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-ip27/dma-coherence.h	2011-10-18 04:06:23.000000000 +0000
@@ -60,7 +60,6 @@ static inline int plat_dma_supported(str
 
 static inline void plat_extra_sync_for_device(struct device *dev)
 {
-	return;
 }
 
 static inline int plat_dma_mapping_error(struct device *dev,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-jazz/dma-coherence.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-jazz/dma-coherence.h
--- linux-3.0/arch/mips/include/asm/mach-jazz/dma-coherence.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-jazz/dma-coherence.h	2011-10-18 04:06:23.000000000 +0000
@@ -50,7 +50,6 @@ static inline int plat_dma_supported(str
 
 static inline void plat_extra_sync_for_device(struct device *dev)
 {
-	return;
 }
 
 static inline int plat_dma_mapping_error(struct device *dev,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-jz4740/gpio.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-jz4740/gpio.h
--- linux-3.0/arch/mips/include/asm/mach-jz4740/gpio.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-jz4740/gpio.h	2011-10-18 04:06:23.000000000 +0000
@@ -25,14 +25,13 @@ enum jz_gpio_function {
     JZ_GPIO_FUNC3,
 };
 
-
 /*
  Usually a driver for a SoC component has to request several gpio pins and
  configure them as funcion pins.
  jz_gpio_bulk_request can be used to ease this process.
  Usually one would do something like:
 
- const static struct jz_gpio_bulk_request i2c_pins[] = {
+ static const struct jz_gpio_bulk_request i2c_pins[] = {
 	JZ_GPIO_BULK_PIN(I2C_SDA),
 	JZ_GPIO_BULK_PIN(I2C_SCK),
  };
@@ -47,8 +46,8 @@ enum jz_gpio_function {
 
     jz_gpio_bulk_free(i2c_pins, ARRAY_SIZE(i2c_pins));
 
-
 */
+
 struct jz_gpio_bulk_request {
 	int gpio;
 	const char *name;
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-loongson/dma-coherence.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-loongson/dma-coherence.h
--- linux-3.0/arch/mips/include/asm/mach-loongson/dma-coherence.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-loongson/dma-coherence.h	2011-10-18 04:06:23.000000000 +0000
@@ -55,7 +55,6 @@ static inline int plat_dma_supported(str
 
 static inline void plat_extra_sync_for_device(struct device *dev)
 {
-	return;
 }
 
 static inline int plat_dma_mapping_error(struct device *dev,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-malta/cpu-feature-overrides.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-malta/cpu-feature-overrides.h
--- linux-3.0/arch/mips/include/asm/mach-malta/cpu-feature-overrides.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-malta/cpu-feature-overrides.h	2011-10-18 04:06:23.000000000 +0000
@@ -32,6 +32,7 @@
 /* #define cpu_has_vtag_icache	? */
 /* #define cpu_has_dc_aliases	? */
 /* #define cpu_has_ic_fills_f_dc ? */
+#define cpu_has_clo_clz		1
 #define cpu_has_nofpuex		0
 /* #define cpu_has_64bits	? */
 /* #define cpu_has_64bit_zero_reg ? */
@@ -58,6 +59,7 @@
 /* #define cpu_has_vtag_icache	? */
 /* #define cpu_has_dc_aliases	? */
 /* #define cpu_has_ic_fills_f_dc ? */
+#define cpu_has_clo_clz		1
 #define cpu_has_nofpuex		0
 /* #define cpu_has_64bits	? */
 /* #define cpu_has_64bit_zero_reg ? */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-mipssim/cpu-feature-overrides.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-mipssim/cpu-feature-overrides.h
--- linux-3.0/arch/mips/include/asm/mach-mipssim/cpu-feature-overrides.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-mipssim/cpu-feature-overrides.h	2011-10-18 04:06:23.000000000 +0000
@@ -31,6 +31,7 @@
 /* #define cpu_has_vtag_icache	? */
 /* #define cpu_has_dc_aliases	? */
 /* #define cpu_has_ic_fills_f_dc ? */
+#define cpu_has_clo_clz		1
 #define cpu_has_nofpuex		0
 /* #define cpu_has_64bits	? */
 /* #define cpu_has_64bit_zero_reg ? */
@@ -56,6 +57,7 @@
 /* #define cpu_has_vtag_icache	? */
 /* #define cpu_has_dc_aliases	? */
 /* #define cpu_has_ic_fills_f_dc ? */
+#define cpu_has_clo_clz		1
 #define cpu_has_nofpuex		0
 /* #define cpu_has_64bits	? */
 /* #define cpu_has_64bit_zero_reg ? */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-powertv/cpu-feature-overrides.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-powertv/cpu-feature-overrides.h
--- linux-3.0/arch/mips/include/asm/mach-powertv/cpu-feature-overrides.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-powertv/cpu-feature-overrides.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,59 @@
+/*
+ * Copyright (C) 2010  Cisco Systems, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef _ASM_MACH_POWERTV_CPU_FEATURE_OVERRIDES_H_
+#define _ASM_MACH_POWERTV_CPU_FEATURE_OVERRIDES_H_
+#define cpu_has_tlb			1
+#define cpu_has_4kex			1
+#define cpu_has_3k_cache		0
+#define cpu_has_4k_cache		1
+#define cpu_has_tx39_cache		0
+#define cpu_has_fpu			0
+#define cpu_has_counter			1
+#define cpu_has_watch			1
+#define cpu_has_divec			1
+#define cpu_has_vce			0
+#define cpu_has_cache_cdex_p		0
+#define cpu_has_cache_cdex_s		0
+#define cpu_has_mcheck			1
+#define cpu_has_ejtag			1
+#define cpu_has_llsc			1
+#define cpu_has_mips16			0
+#define cpu_has_mdmx			0
+#define cpu_has_mips3d			0
+#define cpu_has_smartmips		0
+#define cpu_has_vtag_icache		0
+#define cpu_has_dc_aliases		0
+#define cpu_has_ic_fills_f_dc		0
+#define cpu_has_mips32r1		0
+#define cpu_has_mips32r2		1
+#define cpu_has_mips64r1		0
+#define cpu_has_mips64r2		0
+#define cpu_has_dsp			0
+#define cpu_has_mipsmt			0
+#define cpu_has_userlocal		0
+#define cpu_has_nofpuex			0
+#define cpu_has_64bits			0
+#define cpu_has_64bit_zero_reg		0
+#define cpu_has_vint			1
+#define cpu_has_veic			1
+#define cpu_has_inclusive_pcaches	0
+
+#define cpu_dcache_line_size()		32
+#define cpu_icache_line_size()		32
+#endif
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-powertv/dma-coherence.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-powertv/dma-coherence.h
--- linux-3.0/arch/mips/include/asm/mach-powertv/dma-coherence.h	2011-06-22 15:07:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-powertv/dma-coherence.h	2011-10-18 04:06:23.000000000 +0000
@@ -13,7 +13,6 @@
 #define __ASM_MACH_POWERTV_DMA_COHERENCE_H
 
 #include <linux/sched.h>
-#include <linux/version.h>
 #include <linux/device.h>
 #include <asm/mach-powertv/asic.h>
 
@@ -102,7 +101,6 @@ static inline int plat_dma_supported(str
 
 static inline void plat_extra_sync_for_device(struct device *dev)
 {
-	return;
 }
 
 static inline int plat_dma_mapping_error(struct device *dev,
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-tx39xx/spaces.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-tx39xx/spaces.h
--- linux-3.0/arch/mips/include/asm/mach-tx39xx/spaces.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-tx39xx/spaces.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,17 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 1994 - 1999, 2000, 03, 04 Ralf Baechle
+ * Copyright (C) 2000, 2002  Maciej W. Rozycki
+ * Copyright (C) 1990, 1999, 2000 Silicon Graphics, Inc.
+ */
+#ifndef _ASM_TX39XX_SPACES_H
+#define _ASM_TX39XX_SPACES_H
+
+#define FIXADDR_TOP		((unsigned long)(long)(int)0xfefe0000)
+
+#include <asm/mach-generic/spaces.h>
+
+#endif /* __ASM_TX39XX_SPACES_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/mach-tx49xx/spaces.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-tx49xx/spaces.h
--- linux-3.0/arch/mips/include/asm/mach-tx49xx/spaces.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/mach-tx49xx/spaces.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,17 @@
+/*
+ * This file is subject to the terms and conditions of the GNU General Public
+ * License.  See the file "COPYING" in the main directory of this archive
+ * for more details.
+ *
+ * Copyright (C) 1994 - 1999, 2000, 03, 04 Ralf Baechle
+ * Copyright (C) 2000, 2002  Maciej W. Rozycki
+ * Copyright (C) 1990, 1999, 2000 Silicon Graphics, Inc.
+ */
+#ifndef _ASM_TX49XX_SPACES_H
+#define _ASM_TX49XX_SPACES_H
+
+#define FIXADDR_TOP		((unsigned long)(long)(int)0xfefe0000)
+
+#include <asm/mach-generic/spaces.h>
+
+#endif /* __ASM_TX49XX_SPACES_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/pgtable.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/pgtable.h
--- linux-3.0/arch/mips/include/asm/pgtable.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/pgtable.h	2011-10-18 04:06:23.000000000 +0000
@@ -414,6 +414,7 @@ int phys_mem_access_prot_allowed(struct
  * constraints placed on us by the cache architecture.
  */
 #define HAVE_ARCH_UNMAPPED_AREA
+#define HAVE_ARCH_UNMAPPED_AREA_TOPDOWN
 
 /*
  * No page table caches to initialise
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/smp-ops.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/smp-ops.h
--- linux-3.0/arch/mips/include/asm/smp-ops.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/smp-ops.h	2011-10-18 04:06:23.000000000 +0000
@@ -11,6 +11,8 @@
 #ifndef __ASM_SMP_OPS_H
 #define __ASM_SMP_OPS_H
 
+#include <linux/errno.h>
+
 #ifdef CONFIG_SMP
 
 #include <linux/cpumask.h>
@@ -56,8 +58,43 @@ static inline void register_smp_ops(stru
 
 #endif /* !CONFIG_SMP */
 
-extern struct plat_smp_ops up_smp_ops;
-extern struct plat_smp_ops cmp_smp_ops;
-extern struct plat_smp_ops vsmp_smp_ops;
+static inline int register_up_smp_ops(void)
+{
+#ifdef CONFIG_SMP_UP
+	extern struct plat_smp_ops up_smp_ops;
+
+	register_smp_ops(&up_smp_ops);
+
+	return 0;
+#else
+	return -ENODEV;
+#endif
+}
+
+static inline int register_cmp_smp_ops(void)
+{
+#ifdef CONFIG_MIPS_CMP
+	extern struct plat_smp_ops cmp_smp_ops;
+
+	register_smp_ops(&cmp_smp_ops);
+
+	return 0;
+#else
+	return -ENODEV;
+#endif
+}
+
+static inline int register_vsmp_smp_ops(void)
+{
+#ifdef CONFIG_MIPS_MT_SMP
+	extern struct plat_smp_ops vsmp_smp_ops;
+
+	register_smp_ops(&vsmp_smp_ops);
+
+	return 0;
+#else
+	return -ENODEV;
+#endif
+}
 
 #endif /* __ASM_SMP_OPS_H */
diff -NurpP --minimal linux-3.0/arch/mips/include/asm/smp.h torvalds-linux-v3.1-rc10/arch/mips/include/asm/smp.h
--- linux-3.0/arch/mips/include/asm/smp.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/mips/include/asm/smp.h	2011-10-18 04:06:23.000000000 +0000
@@ -17,7 +17,7 @@
 #include <linux/threads.h>
 #include <linux/cpumask.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/smp-ops.h>
 
 extern int smp_num_siblings;
